# -*- coding: utf-8 -*-
from Tkinter import Toplevel, Label, Button, Text
import sqlite3 as sqlite

class EDN( Toplevel ):
    "Editeur De Notes"
    def  __init__(self, application):
        self.application = application
        Toplevel.__init__(self)
        Label(self, text = "Note :").grid(                               row = 0, column = 0, sticky = 'w' )
        self.zoneDeTexte = Text(self, width = 40, height = 5  )
        self.zoneDeTexte.insert( "end", self.application.text )
        self.zoneDeTexte.grid(                                           row = 1, column = 0)
        Button(self, text = "Enregistrer", command = self.saveNote).grid(row = 2, column = 0, sticky = 'e' )
        self.mainloop()


    def saveNote(self):
        note = self.zoneDeTexte.get( 1.0, "end" )
        # Si la zone de texte est vide. 
        if note.isspace() :# La méthode Text.get donne toujours un \n final. On ne teste pas note != ""
            self.application.cur.execute("""DELETE FROM NOTE
                                            WHERE jour  = ? 
                                            AND   moi   = ?
                                            AND   annee = ?  """,
                                            ( self.application.j,
                                              self.application.m,
                                              self.application.a,
                                            ) )
            self.application.widget.configure( bg = "yellow" )

        else :
            if self.application.requete == "INSERT" :
                self.application.cur.execute("""INSERT INTO NOTE(jour, moi, annee, lib)
                                                            VALUES(?, ?, ?, ?)""",
                                            ( self.application.j,
                                              self.application.m,
                                              self.application.a,
                                              note,
                                            ) )
                self.application.widget.configure( bg = "green" )

            if self.application.requete == "UPDATE" :
                self.application.cur.execute("""UPDATE NOTE set lib = ?
                                                WHERE jour  = ? 
                                                AND   moi   = ?
                                                AND   annee = ?  """, 
                                            ( note,
                                              self.application.j,
                                              self.application.m,
                                              self.application.a,
                                            ) )

        self.application.con.commit()
        self.application.cur.close()
        self.application.con.close()
        self.application.destroy()
        self.destroy()


class GDN( Toplevel ) :
    """
    Gestionnaire De Notes
    widget : Label dont la couleur de fond sera changée par EDN
    m : numéro de moi
    a : année
    """
    def __init__(self, widget, m, a) :
        Toplevel.__init__(self)

        self.j = int( widget.cget( "text" )[ 3: ] )
        self.m = m
        self.a = a

        self.widget = widget
        Label(self, text = str( self.j )+"/"+str(m)+"/"+str(a), anchor = "nw" ).grid(row = 0, column = 0, sticky = 'w')
        self.con = sqlite.connect("BDD/notes.bdd")
        self.cur = self.con.cursor()
        self.cur.execute("""SELECT lib 
                            FROM note
                            WHERE jour = ? and moi = ? and annee = ? """, ( self.j, self.m, self.a, ) )

        note = self.cur.fetchone()
        if note != None :
            self.text = text = note[0]
            self.requete = 'UPDATE'
        else :
            self.text = ''
            text = "(aucune note)"
            self.requete = 'INSERT'

        Label(self, text = text ).grid(row = 1, column = 0)
        Button(self, text = "Editer une note", command = self.editNote).grid(row = 2, column = 0)
        self.mainloop()

    def editNote( self ):
        EDN( self )

